﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;

namespace V409Control
{
    public partial class Connect_Mode : Form
    {

        private Equipment[] equipments = new Equipment[5];
      
        public Connect_Mode(Equipment[] equipment)           //它的构造函数
        {
            InitializeComponent();
            for (int i = 0; i < 5; i++)
            {
                equipments[i] = equipment[i];
            }
            // Socket ss = new Socket(111,121,ProtocolType.Tcp);
        }

        private void Connect_Mode_Load(object sender, EventArgs e)
        {
            //********这里哦，以后要注意一下，更新一下这个类，不然这个类的数组都不可以用***********//实例化个鬼，你再实例化，他的变量就会被直接从新刷新了
        
            /*
            textPIP.Text = equipments[0].NetIpStr;   //一开始卡在这个地方，后来通过在Equipment类中创建几个属性得以解决
            textPPort.Text = equipments[0].NetPort.ToString();
            equipments[0].DisconnectEvent += new DisconnectDelegate(OpenConBtn_DisconnectEvent);*/


            string[] str = SerialPort.GetPortNames();
            if (str != null)
            {
                foreach (string s in str)
                {
                    comPCom.Items.Add(s);
                }
            }

            radioPNet.Checked = !equipments[0].UUart;
            radioPUart.Checked = equipments[0].UUart;
            textPIP.Text = equipments[0].NetIpStr;
            textPPort.Text = equipments[0].NetPort.ToString();
            textPIP.Enabled = radioPNet.Checked;
            textPPort.Enabled = radioPNet.Checked;
            comPCom.Text = (equipments[0].ComNameStr != null) ? equipments[0].ComNameStr : "";
            comPBps.Text = equipments[0].ComBps.ToString();
            comPCom.Enabled = radioPUart.Checked;
            comPBps.Enabled = false;
            this.AcceptButton = this.btnConnSure;

        }

        private void button1_Click(object sender, EventArgs e)
        {
            Boolean checkFlag = false;
            #region 检测串口跟网口打开后是否符合格式要求
            if (radioPUart.Checked)
            {
                if (comPCom.Text == "")
                {
                    checkFlag = true;
                }
            }
            else
            {
                if (textPIP.Text.Length < 7)
                {
                    checkFlag = true;
                }
                if ((textPPort.Text.Length < 1) || (int.Parse(textPPort.Text) < 1))
                {
                    checkFlag = true;
                }
            }
            #endregion
            if (checkFlag)
            {
                MessageBox.Show("填写信息有误，请检查！");
            }
            else
            {
               
                equipments[0].UUart = radioPUart.Checked;  //这个不就是把有无用串口的信息传递出来了吗
                equipments[0].ComNameStr = comPCom.Text;    //这里发生了调用不到的错误
                equipments[0].ComBps = int.Parse(comPBps.Text);//这里将字符串转换为整数
                equipments[0].NetIpStr = textPIP.Text;
                equipments[0].NetPort = int.Parse(textPPort.Text);
                this.Close();
            }
        }
        private void button2_Click(object sender, EventArgs e)
        {       
            comPCom.Items.Clear();                                        //清空ComboBox内容
            string[] str = SerialPort.GetPortNames();
            if (str != null)
            {
                foreach (string s in str)
                {
                    comPCom.Items.Add(s);
                }
            }         
        }
        #region  选择网络通信方式
        private void radioPNet_CheckedChanged(object sender, EventArgs e)
        {
         
        }
      
        public void radioPUart_CheckedChanged(object sender, EventArgs e)
        {
          
            textPIP.Enabled = radioPNet.Checked;
            textPPort.Enabled = radioPNet.Checked;
            comPCom.Enabled = radioPUart.Checked;
        }
        #endregion

        private void groupBox1_Enter(object sender, EventArgs e)
        {

        }
    } 
   
}
