﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO.Ports;

namespace V409Control
{
    public delegate void MyDelegate(Boolean changedFlag);
    public partial class V409控制小程序 : Form
    {
      //  private SimpleScreen simpleScreen;         //定义关于屏幕开窗的数据
      //  private int panelh, panelw;
        //定义该委托的事件 
       // public event MyDelegate MyEvent;

        byte[] SerialPortDataBuffer = new byte[1];
        byte mode=1,win=0, src=0,size=7,x1=1,y1=1,move_model=0,tag=0;//tag是表示画中画的标签
        byte step_L_R = 16;        //左右的动态步长
        byte step_U_D = 9, tip=0;        //上下的动态步长
        byte flag=0,value_H=0,value_V= 0,flag1 = 1;  //value是左右上下的值，flag是开窗模式的标签，flag1是判断哪个位置的窗口的标签。
        byte flag_90 = 0, flag_180 = 0,connect_flag=0;
      
        int  Secret = 10;
        public string row = "1", col = "1" ,src1 = "HDMI①";
        private static int receCount = 0;    // 接收数据量
                                             // 解决线程访问问题
        private object thisLock = new object();    // 锁住线程
        public delegate void SerialPortEventHandler(Object sender, SerialPortEventArgs e);    // 定义委托
        public event SerialPortEventHandler comReceiveDataEvent = null;  // 定义串口接收数据响应事件

        private bool isMouseDown = false;
        private Point mouseOffset; //记录鼠标指针的坐标
        public Equipment[] equipments = new Equipment[5];
        private byte[] net_command = new byte[8] { 0x66, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };

        public V409控制小程序()    //这个是所有程序的入口就在这里
        {
            //所有的程序初始化就在这里完成
            InitializeComponent();
       
           // simpleScreen = new SimpleScreen(this.screen);
        
        }

        private void button8_Click(object sender, EventArgs e)       //3*3模式
        {
            txtRow.Text=3.ToString();
            txtCol.Text=3.ToString();
            button18.Enabled = false;
            if (connect_flag==1)
            {
                net_command[1] = (byte)Equipment.CmdType_a.pin_jie;
                net_command[2] = (byte)0x03;
                net_command[3] = (byte)0x03;
                equipments[0].EquipmentSend(net_command);
            }
            else
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x01);
                equipments[0].WriteByteToSerialPort(0x03);
                equipments[0].WriteByteToSerialPort(0x03);
                equipments[0].WriteByteToSerialPort(0x6d);
            }      
            拼接模式.Text = "拼接模式：3*3";
            Secret = Secret + 2;
            row = "3";
        }

        private void button9_Click(object sender, EventArgs e)      //2*2模式
        {
            if (flag_90 == 0)
            {
                button18.Visible = true;
                button18.Enabled = true;
            }
            else
            {
                button18.Visible = true;
                button18.Enabled = true;
            }    
            txtRow.Text = 2.ToString();
            txtCol.Text = 2.ToString();
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x01);
                equipments[0].WriteByteToSerialPort(0x02);
                equipments[0].WriteByteToSerialPort(0x02);
                equipments[0].WriteByteToSerialPort(0x6b);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.pin_jie;
                net_command[2] = (byte)0x02;
                net_command[3] = (byte)0x02;
                equipments[0].EquipmentSend(net_command);
            }
            拼接模式.Text = "拼接模式：2*2";
            Secret = Secret / 3;
            row = "2";
            col = "2";
          //  MessageBox.Show("ok");
        }

        public bool ReceiveData()
        {

            if (serialPort1 == null)
            {
                return false;
            }
            if (serialPort1.IsOpen == false)
            {
                return false;
            }
            if (serialPort1.BytesToRead <= 0)   // 串口中没有数据
            {
                return false;
            }
            lock (thisLock)   // 锁住串口
            {
                int len = serialPort1.BytesToRead;
                byte[] data = new Byte[len];
                try
                {
                    serialPort1.Read(data, 0, len);   // 向串口中读取数据
                }
                catch (Exception)
                {
                    MessageBox.Show("Data receiving failure！", "提示", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    return false;
                }
                SerialPortEventArgs args = new SerialPortEventArgs();
                args.receivedBytes = data;
                if (comReceiveDataEvent != null)
                {
                    comReceiveDataEvent.Invoke(this, args);
                }
            }
            return true;
        }
        /// <summary>
        /// 串口读取数据响应方法
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void serialPortMonitor_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            ReceiveData();
        }
        public class SerialPortEventArgs : EventArgs
        {
            public byte[] receivedBytes = null;   // 用来接收串口读取的数据
        }

        //串口接收数据功能框
        public void ComReceiveDataEvent(Object sender, SerialPortEventArgs e)
        {
            if (this.InvokeRequired)
            {
                try
                {
                    Invoke(new Action<Object, SerialPortEventArgs>(ComReceiveDataEvent), sender, e);
                }
                catch (Exception)
                {

                }
                return;
            }
            if (Net_tip.Text.Length > 0)
            {
                Net_tip.AppendText(" ");  // 中间使用 隔开，也可以使用-隔开
            }
            Net_tip.AppendText(System.Text.Encoding.Default.GetString(e.receivedBytes));

            // 更新状态显示框
            receCount += e.receivedBytes.Length;
          //  Reveivedate_num.Text = "收到数据: " + receCount.ToString();
        }
        private void Form1_Load(object sender, EventArgs e)
        {      
            comReceiveDataEvent += new SerialPortEventHandler(ComReceiveDataEvent);  // 订阅事件
         
      //     ReceiveData();
            BtnP2Down.Visible = false;
            BtnP2Up.Visible = false;
            BtnP2Left.Visible = false;
            BtnP2Right.Visible = false;
            BtnP4A.Visible = false;
            BtnP4B.Visible = false;
            BtnP4C.Visible = false;
            BtnP4D.Visible = false;
            单画面.Visible = true;
            大窗.Visible = false;
            小窗.Visible = false;
            label8.Visible = true;
            label8.Text = "HDMI-1";
            label9.Visible = false;
            label10.Visible = false;
            label11.Visible = false;
            //****画中画调节控件隐藏****//
            button18.Enabled = false;
            button29.Visible = false;
            button30.Visible = false;
            button31.Visible = false;
            button32.Visible = false;
            button6.Visible = false;
            button1.Visible = false;
            label4.Visible = false;
            //*****旋转控件隐藏*****//
            button17.Visible = false;
            button18.Visible = false;
            connect.Enabled = false;
            this.Controls.Add(this.小窗);
            this.Controls.Add(this.大窗);
            disconnect.Enabled = false;
            button10.Enabled = false;
            //   flag90.Text = flag_90.ToString();
            // flag180.Text = flag_180.ToString();
            //  this.Controls.Add(this.screen);
            for (int i = 0; i < 5; i++)
            {
                equipments[i] = new Equipment();

            }
            string[] str = SerialPort.GetPortNames();
            for (int i = 0; i < 5; i++)
            {
                foreach (string port in str)
                {
                    equipments[i].ComNameStr = str[0];
                }
            }
            //各种按钮的初始化
            radioPNet.Checked = !equipments[0].UUart;
            radioPUart.Checked = equipments[0].UUart;
            textPIP.Text = equipments[0].NetIpStr;
            textPPort.Text = equipments[0].NetPort.ToString();
            textPIP.Enabled = radioPNet.Checked;
            textPPort.Enabled = radioPNet.Checked;
            comPCom.Text = (equipments[0].ComNameStr != null) ? equipments[0].ComNameStr : "";
            comPBps.Text = equipments[0].ComBps.ToString();
            comPCom.Enabled = radioPUart.Checked;
            comPBps.Enabled = false;
            this.AcceptButton = this.btnConnSure;

        }
        private void button12_Click(object sender, EventArgs e)     //1*2模式
        {

            equipments[0].WriteByteToSerialPort(0x66);
            equipments[0].WriteByteToSerialPort(0x01);
            equipments[0].WriteByteToSerialPort(0x01);
            equipments[0].WriteByteToSerialPort(0x02);
            equipments[0].WriteByteToSerialPort(0x6a);
            拼接模式.Text = "拼接模式:1*2";         
        }
        private void button13_Click(object sender, EventArgs e)   //3*1
        {
            txtRow.Text = 3.ToString();
            txtCol.Text = 1.ToString();
            button18.Enabled = false;
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x01);
                equipments[0].WriteByteToSerialPort(0x03);
                equipments[0].WriteByteToSerialPort(0x01);
                equipments[0].WriteByteToSerialPort(0x6b);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.pin_jie;
                net_command[2] = (byte)0x03;
                net_command[3] = (byte)0x01;
                equipments[0].EquipmentSend(net_command);
            }  
            拼接模式.Text = "拼接模式:3*1";
            Secret = Secret * 5;
            row = "3";
        }    
        private void button6_Click(object sender, EventArgs e) //小窗变大
        {
            byte sum = 0;
            if (tag==1)
            {
                flag = 4;
                 if(size<10)
                 size++;
                 else size = 10;
               
                label4.Text = "size:" + size.ToString();
                if (connect_flag == 0)
                {
                    equipments[0].WriteByteToSerialPort(0x66);
                    equipments[0].WriteByteToSerialPort(0x07);
                    equipments[0].WriteByteToSerialPort(size);
                    equipments[0].WriteByteToSerialPort(0x00);
                    sum = (byte)(0x66 + 0x07 + size + 0x00);
                    equipments[0].WriteByteToSerialPort(sum);
                }
                else
                {
                    net_command[1] =(byte)Equipment.CmdType_a.Pip_Size;
                    net_command[2] = size;
                    net_command[3] = 0x00;
                    equipments[0].EquipmentSend(net_command);
                }
                if (小窗.Height > 110 || 小窗.Width > 180)
                {
                    小窗.Height = 小窗.Height + 0;
                    小窗.Width = 小窗.Width + 0;
                }
                else if (小窗.Left == 110 && 小窗.Top == 150)  //左上
                {
                    小窗.Left = 110;
                    小窗.Top = 150;
                    小窗.Height = 小窗.Height + 10;
                    小窗.Width = 小窗.Width + 10;
                   
                }
                else if ((小窗.Height + 小窗.Top) < 330 && 小窗.Left == 110 && 小窗.Top > 150)  //左中贴边
                {
                    小窗.Left = 小窗.Left + 0;
                    小窗.Top = 小窗.Top - 5;
                    小窗.Height = 小窗.Height + 10;
                    小窗.Width = 小窗.Width + 10;                
                }
                else if (小窗.Bottom >= 330 && 小窗.Left == 110)  //左下贴边
                {                  
                    小窗.Height = 小窗.Height + 10;
                    小窗.Width = 小窗.Width + 10;
                    小窗.Left = 小窗.Left + 0;
                    小窗.Top = 小窗.Top - 10;
                }
                else if ((小窗.Height + 小窗.Top) >= 330 && (小窗.Left > 110 && (小窗.Left + 小窗.Width) < 460))  //底中贴边
                {
                    小窗.Height = 小窗.Height + 10;
                    小窗.Width = 小窗.Width + 10;
                    小窗.Left = 小窗.Left - 5;
                    小窗.Top = 小窗.Top - 10;           //为了让它底部贴底
                //    旋转因子.Text = "底中";

                    if (小窗.Left <= 115)
                        小窗.Left = 110;
                    else if (小窗.Left >= (425 - 小窗.Width))
                    {
                   
                        小窗.Left = 430 - 小窗.Width;
                    }
                    else
                    {                 
                        小窗.Left = 小窗.Left - 5;
                    }              
                }
                else if (小窗.Bottom == 330 && 小窗.Right == 430)  //右下贴边
                {
                    //  旋转因子.Text = "右下";
                    小窗.Height = 小窗.Height + 10;
                    小窗.Width = 小窗.Width + 10;
                    小窗.Left = 小窗.Left - 10;
                    小窗.Top = 小窗.Top - 10;
                }

                else if ((小窗.Height + 小窗.Top) < 330 && 小窗.Top > 150 && (小窗.Width + 小窗.Left) == 430) //右中贴边
                {
                   
                    小窗.Height = 小窗.Height + 10;
                    小窗.Width = 小窗.Width + 10;
                    小窗.Left = 小窗.Left - 10;
                    小窗.Top = 小窗.Top - 5;
                }
                else if (小窗.Top == 150 && (小窗.Width + 小窗.Left) == 430) //右上贴边
                {
                   
                    小窗.Left = 小窗.Left - 10;
                    小窗.Top = 小窗.Top + 0;
                    小窗.Height = 小窗.Height + 10;
                    小窗.Width = 小窗.Width + 10;
                }
                else if (小窗.Top == 150 && (小窗.Width + 小窗.Left) < 460 && 小窗.Left > 110) //顶中贴边
                {
                    
                    小窗.Top = 小窗.Top + 0;
                    小窗.Height = 小窗.Height + 10;
                    小窗.Width = 小窗.Width + 10;
                    if (小窗.Left <= 115)
                        小窗.Left = 110;
                      else if (小窗.Left >=(425-小窗.Width))
                    {      
                             小窗.Left = 430 - 小窗.Width;
                    }
                    else
                    {
                       
                        小窗.Left = 小窗.Left - 5;
                    }
                   
                }
                else if (小窗.Top > 150 && (小窗.Top + 小窗.Height) < 330 && 小窗.Left > 110 && (小窗.Width + 小窗.Left) < 430)
                {
                   
                    小窗.Left = 小窗.Left-5;
                    小窗.Top = 小窗.Top-5;
                    小窗.Height = 小窗.Height + 10;
                    小窗.Width = 小窗.Width + 10;
                    if (小窗.Left <= 110)
                        小窗.Left = 110;
                    if (小窗.Top <= 150)
                        小窗.Top = 150;
                    if (小窗.Left >= (430 - 小窗.Width))
                        小窗.Left = 430 - 小窗.Width;
                    if (小窗.Top >= (330 - 小窗.Height))
                        小窗.Top = 330 - 小窗.Height;
                }
                else
                {                 
                    小窗.Left = 小窗.Left - 2;
                    小窗.Top = 小窗.Top +2;
                    小窗.Height = 小窗.Height + 10;
                    小窗.Width = 小窗.Width + 10;
                }
                step_U_D = (byte)((330 - 150 - 小窗.Height) / 10);
                step_L_R = (byte)((430-110-小窗.Width)/10);
            } 
        }   
         
        private void button24_Click(object sender, EventArgs e)  //指定源
        {
            flag = 3;
            src = 0x01;
            src1 = "HDMI-2";
          
        }
        private void button18_Click(object sender, EventArgs e)   //旋转180°
        {
            byte sum;
            flag_180 = (byte)~(flag_180 | 0xfe);
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x03);
                equipments[0].WriteByteToSerialPort(flag_180);
                equipments[0].WriteByteToSerialPort(0x00);
                sum = (byte)(0x66 + 0x03 + flag_180 + 0x00);
                equipments[0].WriteByteToSerialPort(sum);
            }
            else
            {
                net_command[1]=(byte)Equipment.CmdType_a.Rotate_180;
                net_command[2] = flag_180;
                net_command[3] = 0x00;
                equipments[0].EquipmentSend(net_command);
            }   
        }   
        private void button23_Click(object sender, EventArgs e)   //指定源
        {
            flag = 3;
            src = 0x00;
            src1 = "HDMI-1";
        }

        private void button25_Click(object sender, EventArgs e)    //指定源
        {
            flag = 3;
            src = 0x02;
            src1 = "HDMI-3";
        }

        private void button26_Click(object sender, EventArgs e)   //指定源
        {
            flag = 3;
            src = 0x03;
            src1 = "HDMI-4";
        }

        private void button27_Click(object sender, EventArgs e)
        {
            flag = 3;
            src = 0x04;
            src1 = "DP-5";
         
        }

        private void button7_Click(object sender, EventArgs e)  //单画面
        {
            byte sum = 0x00;
            mode = 1;
            tag = 0;
            //***每次刷新窗口，所有的按钮也同时会被刷新，重新让它们出现***//
            button23.Visible = true;
            button24.Visible = true;
            button25.Visible = true;
            button26.Visible = true;
            button27.Visible = true;
            //*****************这里指针对所有的源配置按钮*****************//
            button17.Enabled = true;
            if (row== "2")
            {
                button18.Enabled = true;
            }
            else
            {
                button18.Enabled = false;
            }
            //初始化各个画面的窗口大小
            单画面.Visible = true;
            单画面.Left = BtnP2Left.Left;
            单画面.Top = BtnP2Left.Top;
            单画面.Width   = 320;
            单画面.Height  = 180;
            //左右
            BtnP2Left.Visible = false;
            BtnP2Left.Height = 1;
            BtnP2Left.Width = 1;
            BtnP2Right.Visible = false;
            BtnP2Right.Width = 1;
            BtnP2Right.Height = 1;
            //四画面
            BtnP4A.Visible = false;
            BtnP4A.Width = 1;
            BtnP4A.Height = 1;
            BtnP4B.Visible = false;
            BtnP4B.Height = 1;
            BtnP4B.Width = 1;
            BtnP4C.Visible = false;
            BtnP4C.Width = 1;
            BtnP4C.Height = 1;
            BtnP4D.Visible = false;
            BtnP4D.Height = 1;
            BtnP4D.Width = 1;
            //上下
            BtnP2Down.Visible = false;
            BtnP2Down.Height = 1;
            BtnP2Down.Width = 1;
            BtnP2Up.Visible = false;
            BtnP2Up.Width = 1;
            BtnP2Up.Height = 1;
            //画中画
            大窗.Visible = false;
            大窗.Height = 1;
            大窗.Width = 1;
            小窗.Visible = false;
            小窗.Width = 1;
            小窗.Height = 1;
                  
            label8.Text = "Single Screen:HDMI-1";
            label8.Visible = true;
            label9.Visible = false;
            label10.Visible = false;
            label11.Visible = false;
            //****画中画调节控件隐藏****//      
            button29.Visible = false;
            button30.Visible = false;
            button31.Visible = false;
            button32.Visible = false;
            button6.Visible = false;
            button1.Visible = false;
            label4.Visible = false;

            button17.Visible = true;
            /*新版本的可以通过按键直接把开窗模式配置下发给单片机*/
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x04);
                equipments[0].WriteByteToSerialPort(0x00);
                equipments[0].WriteByteToSerialPort(0x00);
                sum = (byte)(0x66 + 0x04 + 0x00 + 0x00);
                equipments[0].WriteByteToSerialPort(sum);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.Muil_Mode;     //发送0xfd这个命令给下位机
                net_command[2] = (byte)0x00;
                equipments[0].EquipmentSend(net_command);
            }           
         
        }
        private void button19_Click(object sender, EventArgs e) //画中画
        {
          
            byte sum = 0x00;
            mode =4;
            tag = 1;
            size = 8;
            button17.Enabled = false;
            flag_90 = 0;
            //***每次刷新窗口，所有的按钮也同时会被刷新，重新让它们出现***//
            button23.Visible = true;
            button24.Visible = true;
            button25.Visible = true;
            button26.Visible = true;
            button27.Visible = true;
            //*****************这里指针对所有的源配置按钮*****************//
            if (row == "2")
            {
                button18.Enabled = true;
            }
            else
            {
                button18.Enabled = false;
            }        
            label8.Text = "Large Screen:HDMI-1";
            label8.Visible = true;
            label10.Text = "Little Screen:HDMI-2";
            label10.Visible = true;
            label9.Visible = false;
            label11.Visible = false;

            大窗.Visible = true;
            大窗.Height =180;
            大窗.Width = 320;
            大窗.Left = 小窗.Left;
            大窗.Top = 小窗.Top;
            小窗.Visible = true;
            小窗.Height =90;
            小窗.Width =160;
          

            //初始化各个画面的窗口大小
            单画面.Visible = true;
         
            单画面.Width = 1;
            单画面.Height = 1;
            //左右
            BtnP2Left.Visible = false;
            BtnP2Left.Height = 1;
            BtnP2Left.Width = 1;
            BtnP2Right.Visible = false;
            BtnP2Right.Width = 1;
            BtnP2Right.Height = 1;
            //四画面
            BtnP4A.Visible = false;
            BtnP4A.Width = 1;
            BtnP4A.Height = 1;
            BtnP4B.Visible = false;
            BtnP4B.Height = 1;
            BtnP4B.Width = 1;
            BtnP4C.Visible = false;
            BtnP4C.Width = 1;
            BtnP4C.Height = 1;
            BtnP4D.Visible = false;
            BtnP4D.Height = 1;
            BtnP4D.Width = 1;
            //上下
            BtnP2Down.Visible = false;
            BtnP2Down.Height = 1;
            BtnP2Down.Width = 1;
            BtnP2Up.Visible = false;
            BtnP2Up.Width = 1;
            BtnP2Up.Height = 1;

            //****画中画调节控件隐藏****//

            button29.Visible = true;
            button30.Visible = true;
            button31.Visible = true;
            button32.Visible = true;
            button6.Visible = true;
            button1.Visible = true;
            label4.Visible = true;
            button17.Visible = false;
        

            /*新版本的可以通过按键直接把开窗模式配置下发给单片机*/
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x04);
                equipments[0].WriteByteToSerialPort(0x03);
                equipments[0].WriteByteToSerialPort(0x00);
                sum = (byte)(0x66 + 0x04 + 0x03 + 0x00);
                equipments[0].WriteByteToSerialPort(sum);
                Delay(300);

                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x06);
                equipments[0].WriteByteToSerialPort(0x01);
                equipments[0].WriteByteToSerialPort(0x00);
                sum = (byte)(0x66 + 0x06 + 0x01 + 0x00);
                equipments[0].WriteByteToSerialPort(sum);
                Delay(300);

                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x06);
                equipments[0].WriteByteToSerialPort(0x00);
                equipments[0].WriteByteToSerialPort(0x00);
                sum = (byte)(0x66 + 0x06 + 0x00 + 0x00);
                equipments[0].WriteByteToSerialPort(sum);
                Delay(300);

                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x07);
                equipments[0].WriteByteToSerialPort(0x0A);
                equipments[0].WriteByteToSerialPort(0x00);
                sum = (byte)(0x66 + 0x07 + 0x0A + 0x00);
                equipments[0].WriteByteToSerialPort(sum);
                Delay(300);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.Muil_Mode;
                net_command[2] = (byte)0x03;
                equipments[0].EquipmentSend(net_command);
                //  Delay(500);
                timeDelay(300);

                net_command[1] = (byte)Equipment.CmdType_a.Pip_Loc;
                net_command[2] = (byte)0x01;
                equipments[0].EquipmentSend(net_command);
                //   Delay(500);
                timeDelay(300);

                net_command[1] = (byte)Equipment.CmdType_a.Pip_Loc;
                net_command[2] = (byte)0x00;
                equipments[0].EquipmentSend(net_command);
                // Delay(500);
                timeDelay(300);

                net_command[1] = (byte)Equipment.CmdType_a.Pip_Size;
                net_command[2] = (byte)0x0A;
                equipments[0].EquipmentSend(net_command);
                //  Delay(500);
                timeDelay(300);
            }
        }
        private void button20_Click(object sender, EventArgs e)  //双画面左右
        {
            byte sum = 0x00;
            mode = 2;
            tag = 0;
            button17.Enabled = false;     //旋转90°去能
            flag_90 = 0;


            //***每次刷新窗口，所有的按钮也同时会被刷新，重新让它们出现***//
            button23.Visible = true;
            button24.Visible = true;
            button25.Visible = true;
            button26.Visible = true;
            button27.Visible = true;
            //*****************这里指针对所有的源配置按钮*****************//
            if (row == "2")
            {             
                button18.Enabled = true;
            }
            else
            {
                button18.Enabled = false;
            }

            //初始化各个画面的窗口大小
            //四画面
            BtnP4A.Visible = false;
         
            BtnP4A.Width = 1;
            BtnP4A.Height = 1;
            BtnP4B.Visible = false;
            BtnP4B.Height = 1;
            BtnP4B.Width = 1;
          
            BtnP4C.Visible = false;
            BtnP4C.Width = 1;
            BtnP4C.Height = 1;
         
            BtnP4D.Visible = false;
            BtnP4D.Height = 1;
            BtnP4D.Width = 1;
           
            //单画面
            单画面.Visible = false;
        
            单画面.Width = 1;
            单画面.Height = 1;
            //左右
            BtnP2Left.Visible = true;
            BtnP2Left.Height = 180;
            BtnP2Left.Width = 160;
            
            BtnP2Right.Visible = true;
            BtnP2Right.Width = 160;
            BtnP2Right.Height = 180;
         
            //上下
            BtnP2Down.Visible = false;
            BtnP2Down.Height = 1;
            BtnP2Down.Width = 1;
            BtnP2Up.Visible = false;
            BtnP2Up.Width = 1;
            BtnP2Up.Height = 1;
            //画中画
            大窗.Visible = false;
            大窗.Height = 1;
            大窗.Width = 1;
            小窗.Visible = false;
            小窗.Width = 1;
            小窗.Height = 1;

            //****画中画调节控件隐藏****//
//            button18.Enabled = false;
            button29.Visible = false;
            button30.Visible = false;
            button31.Visible = false;
            button32.Visible = false;
            button6.Visible = false;
            button1.Visible = false;
            label4.Visible = false;

            button17.Visible = false;
        //    button18.Visible = false;

            label8.Text = "Left Screen:HDMI-1";
            label8.Visible = true;
            label10.Text = "Right Screen:HDMI-2";
            label10.Visible = true;
        
            label9.Visible = false;
          
            label11.Visible = false;


            /*新版本的可以通过按键直接把开窗模式配置下发给单片机*/
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x04);
                equipments[0].WriteByteToSerialPort(0x01);
                equipments[0].WriteByteToSerialPort(0x00);
                sum = (byte)(0x66 + 0x04 + 0x01 + 0x00);
                equipments[0].WriteByteToSerialPort(sum);
            }

            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.Muil_Mode;     
                net_command[2] = (byte)0x01;
                equipments[0].EquipmentSend(net_command);
            }  
         
        }

        private void button21_Click(object sender, EventArgs e) //双画面上下
        {
            byte sum = 0x00;
            mode = 3;
            tag = 0;
            button17.Enabled = false;
            flag_90 = 0;
            //***每次刷新窗口，所有的按钮也同时会被刷新，重新让它们出现***//
            button23.Visible = true;
            button24.Visible = true;
            button25.Visible = true;
            button26.Visible = true;
            button27.Visible = true;
            //*****************这里指针对所有的源配置按钮*****************//
            if (row == "2")
            {
                button18.Enabled = true;
            }
            else
            {
                button18.Enabled = false;
            }

            /*  button7.Enabled = true;
              button19.Enabled = true;
              button20.Enabled = true;
              button21.Enabled = false;
              button22.Enabled = true;*/
            //chu shi hua
            BtnP4A.Visible = false;
          
            BtnP4A.Width = 1;
            BtnP4A.Height = 1;
            BtnP4B.Visible = false;
            BtnP4B.Height = 1;
            BtnP4B.Width = 1;
       
            BtnP4C.Visible = false;
            BtnP4C.Width = 1;
            BtnP4C.Height = 1;
         
            BtnP4D.Visible = false;
            BtnP4D.Height = 1;
            BtnP4D.Width = 1;
            
            //单画面
            单画面.Visible = false;
       
            单画面.Width = 1;
            单画面.Height = 1;
            //左右
            BtnP2Left.Visible = false;
            BtnP2Left.Height = 1;
            BtnP2Left.Width = 1;
          
            BtnP2Right.Visible = false;
            BtnP2Right.Width = 1;
            BtnP2Right.Height = 1;
         
            //上下
            BtnP2Up.Visible = true;
            BtnP2Up.Width = 320;
            BtnP2Up.Height = 90;
           
            BtnP2Down.Visible = true;
            BtnP2Down.Height = 90;
            BtnP2Down.Width = 320;
           
            //画中画
            大窗.Visible = false;
            大窗.Height = 1;
            大窗.Width = 1;
            小窗.Visible = false;
            小窗.Width = 1;
            小窗.Height = 1;

            //****画中画调节控件隐藏****//
//            button18.Enabled = false;
            button29.Visible = false;
            button30.Visible = false;
            button31.Visible = false;
            button32.Visible = false;
            button6.Visible = false;
            button1.Visible = false;
            label4.Visible = false;

            button17.Visible = false;
         //   button18.Visible = false;

            label8.Text = "Up Screen:HDMI-1";
            label8.Visible = true;
            label9.Text = "Down Screen:HDMI-2";
            label9.Visible = true;
      
            label10.Visible = false;
            label11.Visible = false;



            /*新版本的可以通过按键直接把开窗模式配置下发给单片机*/
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x04);
                equipments[0].WriteByteToSerialPort(0x04);
                equipments[0].WriteByteToSerialPort(0x00);
                sum = (byte)(0x66 + 0x04 + 0x04 + 0x00);
                equipments[0].WriteByteToSerialPort(sum);
            }
            else
            {
            net_command[1] = (byte)Equipment.CmdType_a.Muil_Mode;     //发送0xfd这个命令给下位机
            net_command[2] = (byte)0x04;
            equipments[0].EquipmentSend(net_command);
            }    
          
        }

        private void button22_Click(object sender, EventArgs e) //四画面
        {
            byte sum = 0x00;
            mode = 5;
            tag = 0;
            button17.Enabled = false;
            flag_90 = 0;
            //***每次刷新窗口，所有的按钮也同时会被刷新，重新让它们出现***//
            button23.Visible = true;
            button24.Visible = true;
            button25.Visible = true;
            button26.Visible = true;
            button27.Visible = true;
            //*****************这里指针对所有的源配置按钮*****************//
            if (row == "2")
            {
                button18.Enabled = true;
            }
            else
            {
                button18.Enabled = false;
            }
            /* button7.Enabled = true;
             button19.Enabled = true;
             button20.Enabled = true;
             button21.Enabled = true;
             button22.Enabled =  false;*/

            //初始化各个画面的窗口大小
            //四画面
            BtnP4A.Visible = true;
      
            BtnP4A.Width = 160;
            BtnP4A.Height = 90;
            BtnP4B.Visible = true;
            BtnP4B.Height = 90;
            BtnP4B.Width = 160;
       
            BtnP4C.Visible = true;
            BtnP4C.Width = 160;
            BtnP4C.Height = 90;
          
            BtnP4D.Visible = true;
            BtnP4D.Height = 90;
            BtnP4D.Width = 160;
            
            //单画面
            单画面.Visible = false;
          
            单画面.Width = 1;
            单画面.Height = 1;
            //左右
            BtnP2Left.Visible = false;
            BtnP2Left.Height = 1;
            BtnP2Left.Width = 1;
            BtnP2Right.Visible = false;
            BtnP2Right.Width = 1;
            BtnP2Right.Height = 1;
            //上下
            BtnP2Down.Visible = false;
            BtnP2Down.Height = 1;
            BtnP2Down.Width = 1;
            BtnP2Up.Visible = false;
            BtnP2Up.Width = 1;
            BtnP2Up.Height = 1;
            //画中画
            大窗.Visible = false;
            大窗.Height = 1;
            大窗.Width = 1;
            小窗.Visible = false;
            小窗.Width = 1;
            小窗.Height = 1;

            //****画中画调节控件隐藏****//

            button29.Visible = false;
            button30.Visible = false;
            button31.Visible = false;
            button32.Visible = false;
            button6.Visible = false;
            button1.Visible = false;
            label4.Visible = false;

            button17.Visible = false;
      

            label8.Text = "Left-Up-Screen:HDMI-1";
            label8.Visible = true;
            label10.Text = "Right-Up-Screen:HDMI-3";
            label10.Visible = true;
            label9.Text = "Left-Down-Screen:HDMI-2";
            label9.Visible = true;
            label11.Text = "Rignt-Down-Screen:HDMI-4";
            label11.Visible = true;

            /*新版本的可以通过按键直接把开窗模式配置下发给单片机*/
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x04);
                equipments[0].WriteByteToSerialPort(0x02);
                equipments[0].WriteByteToSerialPort(0x00);
                sum = (byte)(0x66 + 0x04 + 0x02 + 0x00);
                equipments[0].WriteByteToSerialPort(sum);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.Muil_Mode;
                net_command[2] = (byte)0x02;
                equipments[0].EquipmentSend(net_command);
            }
           
         

        }

        private void label6_Click(object sender, EventArgs e)
        {

        }
       /* private void ScreenSet_Load(object sender, EventArgs e)
        {
            txtRow.Text = simpleScreen.RowNumber.ToString();
            txtCol.Text = simpleScreen.ColumnNumber.ToString();
            this.AcceptButton = this.btnPsetSure;
        }*/
        private void txtRow_TextChanged(object sender, EventArgs e)  //获得行的值
        {
            if (txtRow.Text != null)
            {
              
                    row = txtRow.Text;
                
            }
           else
                    row = "1";
        }

        private void txtCol_TextChanged(object sender, EventArgs e)  //获得列的值
        {
            if (txtCol.Text != null)
            {
            
                    col = txtCol.Text;
                
            }
            else
                    col = "1";        
        }

        private void LimitNumber(object sender, KeyPressEventArgs e)
        {

        }

        private void BtnP2Right_Click(object sender, EventArgs e)
        {
            flag = 3;
            flag1 = 2;
            win = 0x01;
            BtnP2Right.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
            BtnP2Left.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
        }
        private void BtnP2Down_Click(object sender, EventArgs e)
        {
            flag = 3;
            flag1 = 2;
            win = 0x01;
            BtnP2Up.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
            BtnP2Down.BackColor = System.Drawing.Color.FromArgb(210,250,128);
        }

        private void BtnP2Up_Click(object sender, EventArgs e)
        {
            flag = 3;
            flag1 = 1;
            win = 0x00;
            BtnP2Up.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
            BtnP2Down.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
        }
        private void BtnP2Left_Click(object sender, EventArgs e)
        {
            flag = 3;
            flag1 = 1;
            win = 0x00;
            BtnP2Left.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
            BtnP2Right.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
        }
      
        private void button31_Click(object sender, EventArgs e)  //zuo
        {
            byte sum = 0x00;
            if (tag == 1)
            {
                move_model = 0;
                if (value_H > 0)
                    value_H = (byte)(value_H - 10);
                else value_H = 0;

                if (connect_flag == 0)
                {
                    equipments[0].WriteByteToSerialPort(0x66);
                    equipments[0].WriteByteToSerialPort(0x06);
                    equipments[0].WriteByteToSerialPort(move_model);
                    equipments[0].WriteByteToSerialPort(value_H);
                    sum = (byte)(0x66 + 0x06 + move_model + value_H);
                    equipments[0].WriteByteToSerialPort(sum);
                }
                else
                {
                    net_command[1] = (byte)Equipment.CmdType_a.Pip_Loc;
                    net_command[2] = move_model;
                    net_command[3] = value_H;
                    equipments[0].EquipmentSend(net_command);
                }
                小窗.Left = 小窗.Left -step_L_R;
                if (小窗.Left < 110)
                    小窗.Left = 110;
            }
        }
        private void button30_Click(object sender, EventArgs e)  //you
        {
            byte sum = 0x00;
            if (tag == 1)
            {
                move_model = 0;
                if (value_H < 99)
                    value_H = (byte)(value_H + 10);
                else value_H = 100;
                if (connect_flag == 0)
                {
                    equipments[0].WriteByteToSerialPort(0x66);
                    equipments[0].WriteByteToSerialPort(0x06);
                    equipments[0].WriteByteToSerialPort(move_model);
                    equipments[0].WriteByteToSerialPort(value_H);
                    sum = (byte)(0x66 + 0x06 + move_model + value_H);
                    equipments[0].WriteByteToSerialPort(sum);
                }
                else
                {
                    net_command[1] = (byte)Equipment.CmdType_a.Pip_Loc;
                    net_command[2] = move_model;
                    net_command[3] = value_H;
                    equipments[0].EquipmentSend(net_command);
                }
                小窗.Left = 小窗.Left + step_L_R;
                if (小窗.Left > (430-小窗.Width))
                    小窗.Left = (430 - 小窗.Width);
            }
        }
        private void button29_Click(object sender, EventArgs e)  //shang
        {
            byte sum = 0x00;
            if (tag == 1)        //tag是表示画中画的标签
            {
                move_model = 1;
                if (value_V >0)
                    value_V = (byte)(value_V - 10);
                else value_V = 0;
                if (connect_flag == 0)
                {
                    equipments[0].WriteByteToSerialPort(0x66);
                    equipments[0].WriteByteToSerialPort(0x06);
                    equipments[0].WriteByteToSerialPort(move_model);
                    equipments[0].WriteByteToSerialPort(value_V);
                    sum = (byte)(0x66 + 0x06 + move_model + value_V);
                    equipments[0].WriteByteToSerialPort(sum);
                }
               else
                {
                    net_command[1] =(byte)Equipment.CmdType_a.Pip_Loc;
                    net_command[2] =move_model;
                    net_command[3] =value_V;
                    equipments[0].EquipmentSend(net_command);
                }
                小窗.Top = 小窗.Top - step_U_D;
                if (小窗.Top < 150)
                    小窗.Top = 150;
            }
        }
       

        private void 大窗_Click(object sender, EventArgs e)    //大窗

        {
            flag = 3;
            win = 0x00;
            flag1 = 1;
            大窗.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
            小窗.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
        }

        private void button2_Click(object sender, EventArgs e)  //3*2
        {
            if (flag_90 == 1)
            {
                button18.Visible = true;
                button18.Enabled = true;
            }
            else if (flag_90 == 0)
            {
                button18.Enabled = false;
            }
                
            txtRow.Text = 3.ToString();
            txtCol.Text = 2.ToString();
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x01);
                equipments[0].WriteByteToSerialPort(0x03);
                equipments[0].WriteByteToSerialPort(0x02);
                equipments[0].WriteByteToSerialPort(0x6c);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.pin_jie;
                net_command[2] = (byte)0x03;
                net_command[3] = (byte)0x02;
                equipments[0].EquipmentSend(net_command);
            }
          
            拼接模式.Text = "拼接模式：3*2";
            Secret = Secret * 4;
            row = "3";
            col = "2";
           
        }
        private void button3_Click(object sender, EventArgs e)  //2*3
        {
            if (flag_90 == 0)
            {
                button18.Enabled = true;
                button18.Visible = true;
            }              
            else if(flag_90 == 1)
            {
                button18.Enabled = false;
              //  button18.Visible = false;
            }
               
            txtRow.Text = 2.ToString();
            txtCol.Text = 3.ToString();
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x01);
                equipments[0].WriteByteToSerialPort(0x02);
                equipments[0].WriteByteToSerialPort(0x03);
                equipments[0].WriteByteToSerialPort(0x6c);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.pin_jie;
                net_command[2] = (byte)0x02;
                net_command[3] = (byte)0x03;
                equipments[0].EquipmentSend(net_command);
            }
            拼接模式.Text = "拼接模式：2*3";
            Secret = Secret / 2;
            row = "2";
            col = "3";
         
        }

        private void label11_Click(object sender, EventArgs e)
        {

        }
        private void OpenConBtn_DisconnectEvent(Boolean reConnect)
        {
            if (reConnect)
            {
                equipments[0].EquipmentClose();
               // conn_set.Enabled = true;
                connect.Enabled = true;
                disconnect.Enabled = false;
              
               log_Output("Please reconnect");
            }
            else
            {
                log_Output("Please open the connection first");
            }
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
             equipments[0].ReceiveData();
             if (equipments[0].readflag)
             {

                 equipments[0].readflag = false;
                 Net_tip.Text += string.Concat(equipments[0].buf);
                 if (equipments[0].UUart)
                 {
                     equipments[0].HeartBeatReTries = 0;
                 }
                 else if (equipments[0].AckPktBuf[0] == 0xd6
                     && equipments[0].AckPktBuf[1] == (byte)Equipment.CmdType.HeartBeat)
                 {
                
                     equipments[0].HeartBeatReTries = 0;
                 }
             }

             if (equipments[0].UUart && equipments[0].GetEquipmentStat())
             {
                
                 equipments[0].HeartBeatReTries = 0;
             }

             //send heartbeat package more than 4, indicate that server can not access
             if (equipments[0].HeartBeatReTries > equipments[0].HeartBeatMaxTryNum)
             {
               
//                 OpenConBtn_DisconnectEvent(true);
                 equipments[0].HeartBeatReTries = 0;
                //                this.disconnect.Click += new System.EventHandler(this.disconnect_Click);
                //                this.connect.Click += new System.EventHandler(this.connect_Click);

                equipments[0].EquipmentClose();
                equipments[0].EquipmentConnect();
                log_Output("Reconnect");
//                 MessageBox.Show("连接异常断开，请尝试重新连接", "告警", MessageBoxButtons.OK, MessageBoxIcon.Information);
//                 timer1.Stop();
//                 timer2.Stop();
            }
        }
        private void log_Output(string text)
        {
            string dateStr = DateTime.Now.ToString();
            Net_tip.AppendText("[" + dateStr + "]:" + text + System.Environment.NewLine);
        }
        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            AboutBox aboutInfo = new AboutBox();
            aboutInfo.ShowDialog(this);
        } 

        private void 退出ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        #region 林
        private void connect_Click(object sender, EventArgs e)
        {
            string strcom = "";
            string strnet = "";
          
            equipments[0].EquipmentConnect();
             if (equipments[0].GetEquipmentStat())   //果然，没进来到这里
             {
         
               /****现在的问题就是，这个串口的标志位不生效果，这是为什么呢，原因就是每次进入到设置模式界面，我都给它初始化掉了，所以那个值一直都为原来的初始值****/
                if (equipments[0].uUart)   //如果是串口那我把串口号加进去
                {
                    connect_flag = 0;
                strcom += equipments[0].ComNameStr; 
                }
                else                      //如果是网口，我就把网口号加进去
                {
                strnet += equipments[0].NetIpStr; 
                    connect_flag = 1;
                }    
              }
              if ((strcom != "") || (strnet != ""))
              {
              
                  log_Output(strcom + strnet+ "  Tcp_Connected!");        //这一行是在那个框里面做了提醒
                   
                ////*****只有进入来了这里，表示连接成功了之后，才会让那个连接按钮灭掉*****////     
                  connect.Enabled = false;
                  disconnect.Enabled = true;
                  radioPNet.Enabled = false;
                  radioPUart.Enabled = false;
                  timer1.Start();    
                  timer2.Start();       
            }
              else
              {          
                log_Output("Unable to connect to any device！\n");
              }
           
        }
  #endregion
        private void disconnect_Click(object sender, EventArgs e)
        {
            equipments[0].EquipmentClose();
            timer1.Stop();
            timer2.Stop();
            log_Output( "Tcp_Disconnect");     //这一行是在那个框里面做了提醒
            connect.Enabled = true;
            disconnect.Enabled = false;
            radioPUart.Enabled = true;
            radioPNet.Enabled = true;

            //通讯设置菜单使能                        
         //   conn_set.Enabled = true;

        }     
        private void button5_Click(object sender, EventArgs e)
        {
            Net_tip.Text = "";   // 清空接收数据
        }
        private void timer2_Tick(object sender, EventArgs e)
        {         
            if (disconnect.Enabled)
            {
                equipments[0].HeartBeatReTries++;
                if (!equipments[0].UUart)
                {
                    equipments[0].HeartBeat[2] = (byte)equipments[0].HeartBeatReTries;
                    equipments[0].HeartBeat[1] = (byte)Equipment.CmdType.HeartBeat;
                    equipments[0].EquipmentSend(equipments[0].HeartBeat);
                }     
            }      
        }

        private void menuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {

        }
        private void button23_MouseUp(object sender, MouseEventArgs e)
        {
            byte sum = 0x00;
            if (e.Button == MouseButtons.Left)
            {
                isMouseDown = false;

                //**这个是判断在哪个窗停留下的，所以应该先判断一下开窗的模式吧?**//
                switch (mode)
                {
                    case 1:
                        {
                           if (button23.Left >= 110 && button23.Left <= 430 && button23.Top >= 150 && button23.Top <= 330)
                          
                            {
                                单画面.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                                win = 0x00;
                            }
                            label8.Text = "Single Screen:" + src1.ToString();
                            break;
                        }
                    case 2:
                        if (button23.Left  >= 110 && button23.Left <= 270 && button23.Top >= 150 && button23.Top <= 330)
                        {
                            //  在画面左的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP2Left.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP2Right.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);                          
                        }
                        else if(button23.Left >= 271&& button23.Left <= 430 && button23.Top >= 150 && button23.Top <= 330)
                        {
                            //  在画面右的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            BtnP2Right.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            BtnP2Left.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);                        
                        }
                        if (flag1 == 1) label8.Text = "Left Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Right Screen:" + src1.ToString(); break;
                    case 3:
                        if (button23.Left  >= 110 && button23.Left  <= 430 && button23.Top >= 150 && button23.Top <= 240)
                        {
                            //  在画面上的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP2Up.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP2Down.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button23.Left >= 110 && button23.Left <= 430 && button23.Top >= 241 && button23.Top <= 330)
                        {
                            //  在画面下的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            BtnP2Up.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP2Down.BackColor = System.Drawing.Color.FromArgb(210, 250, 128);
                        }
                        if (flag1 == 1) label8.Text = "Up Screen:" + src1.ToString();
                        if (flag1 == 2) label9.Text = "Down Screen:" + src1.ToString(); break;
                    case 4:
                        if (button23.Left  >= 小窗.Left && button23.Left<= (小窗.Left+小窗.Width) && button23.Top >=小窗.Top && button23.Top <= (小窗.Top+小窗.Height))
                        {
                            //  在小窗的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            小窗.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            大窗.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else 
                        {
                            //  在大窗的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            大窗.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            小窗.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        if (flag1 == 1) label8.Text = "Large Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Little Screen:" + src1.ToString(); break;
                    case 5:
                        if (button23.Left >= 110 && button23.Left  <= 270 && button23.Top >= 150 && button23.Top <= 240)
                        {
                            //  在小窗A的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button23.Left>= 270 && button23.Left  <= 430 && button23.Top >= 150 && button23.Top <= 240)
                        {
                            //  在小窗B的坐标系里面
                            flag1 = 2;
                            win = 0x02;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(221, 160, 220);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button23.Left >= 110 &&button23.Left  <= 270 && button23.Top >= 240 && button23.Top <= 330)
                        {
                            //  在小窗C的坐标系里面
                            flag1 = 3;
                            win = 0x01;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if(button23.Left >= 271 && button23.Left <= 430 && button23.Top >= 240 && button23.Top <= 330)
                        {
                            //  在小窗D的坐标系里面
                            flag1 = 4;
                            win = 0x03;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(110, 50, 150);
                        }
                        if (flag1 == 1) label8.Text = "Left-Up-Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Right-Up-Screen:" + src1.ToString();
                        if (flag1 == 3) label9.Text = "Left-Down-Screen:" + src1.ToString();
                        if (flag1 == 4) label11.Text = "Rignt-Down-Screen:" + src1.ToString(); break;
                    default: break;
                }
                int left = button24.Left - 90;
                int top = button24.Top;
                button23.Location = new Point(left, top);
                /*  button23.Visible = false;
                  button24.Visible = true;
                  button25.Visible = true;
                  button26.Visible = true;
                  button27.Visible = true;*/
            }
           
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x05);
                equipments[0].WriteByteToSerialPort(win);
                equipments[0].WriteByteToSerialPort(src);
                sum = (byte)(0x66 + 0x05 + win + src);
                equipments[0].WriteByteToSerialPort(sum);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.Source_Mode;
                net_command[2] = win;
                net_command[3] = src;
                equipments[0].EquipmentSend(net_command);
            }
        }
        private void button24_MouseUp(object sender, MouseEventArgs e)
        {

            byte sum = 0x00;
            if (e.Button == MouseButtons.Left)
            {
                isMouseDown = false;
                //**这个是判断在哪个窗停留下的，所以应该先判断一下开窗的模式吧?**//
                switch (mode)
                {
                    case 1:
                        {
                            if (button24.Left >= 110 && button24.Left <= 430 && button24.Top >= 150 && button24.Top <= 330)
                            {
                                单画面.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                                win = 0x00;
                            }
                            label8.Text = "Single Screen:" + src1.ToString();
                            break;
                        }
                    case 2:
                        if (button24.Left  >= 110 && button24.Left  <= 270 && button24.Top >= 150 && button24.Top <= 330)
                        {
                            //  在画面左的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP2Left.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP2Right.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);                          
                        }
                        else  if (button24.Left >= 271 && button24.Left <= 430 && button24.Top >= 150 && button24.Top <= 330)  //画面右
                        {
                            //  在画面右的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            BtnP2Right.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            BtnP2Left.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                          
                        }
                        if (flag1 == 1) label8.Text = "Left Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Right Screen:" + src1.ToString(); break;
                    case 3:
                        if (button24.Left  >= 110 && button24.Left  <= 430 && button24.Top >= 150 && button24.Top <= 240)
                        {
                            //  在画面上的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP2Up.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP2Down.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button24.Left >= 110 && button24.Left <= 430 && button24.Top >= 241 && button24.Top <= 330)   //画面下
                        {
                            //  在画面下的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            BtnP2Up.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP2Down.BackColor = System.Drawing.Color.FromArgb(210, 250, 128);
                        }
                        if (flag1 == 1) label8.Text = "Up Screen:" + src1.ToString();
                        if (flag1 == 2) label9.Text = "Down Screen:" + src1.ToString(); break;
                    case 4:
                        if (button24.Left >= 小窗.Left && button24.Left <= (小窗.Left + 小窗.Width) && button24.Top >= 小窗.Top && button24.Top <= (小窗.Top + 小窗.Height))
                        {
                            //  在小窗的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            小窗.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            大窗.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        //   else if (button24.Left >= 110 && button24.Left < 小窗.Left && button24.Left > (小窗.Left + 小窗.Width) && button24.Left <= 430 && button24.Top >= 150 && button24.Top < 小窗.Top && button24.Top > (小窗.Top + 小窗.Height) && button24.Top < 330)
                        else
                        {
                            //  在大窗的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            大窗.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            小窗.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        if (flag1 == 1) label8.Text = "Large Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Little Screen:" + src1.ToString(); break;
                    case 5:
                        if (button24.Left  >= 110 && button24.Left <= 270 && button24.Top >= 150 && button24.Top <= 240)
                        {
                            //  在小窗A的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button24.Left  >= 270 && button24.Left  <= 430 && button24.Top >= 150 && button24.Top <= 240)
                        {
                            //  在小窗B的坐标系里面
                            flag1 = 2;
                            win = 0x02;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(221, 160, 220);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button24.Left >= 110 && button24.Left  <= 270 && button24.Top >= 240 && button24.Top <= 330)
                        {
                            //  在小窗C的坐标系里面
                            flag1 = 3;
                            win = 0x01;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button24.Left >= 271 && button24.Left <= 430 && button24.Top >= 240 && button24.Top <= 330) //P4  
                        {
                            //  在小窗D的坐标系里面
                            flag1 = 4;
                            win = 0x03;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(110, 50, 150);
                        }
                        if (flag1 == 1) label8.Text = "Left-Up-Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Right-Up-Screen:" + src1.ToString();
                        if (flag1 == 3) label9.Text = "Left-Down-Screen:" + src1.ToString();
                        if (flag1 == 4) label11.Text = "Rignt-Down-Screen:" + src1.ToString(); break;
                    default: break;
                }
                int left = button23.Left + 90;
                int top = button23.Top;
                button24.Location = new Point(left, top);
                /*   button24.Visible = false;
                   button23.Visible = true;
                   button25.Visible = true;
                   button26.Visible = true;
                   button27.Visible = true;*/
            }
          
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x05);
                equipments[0].WriteByteToSerialPort(win);
                equipments[0].WriteByteToSerialPort(src);
                sum = (byte)(0x66 + 0x05 + win + src);
                equipments[0].WriteByteToSerialPort(sum);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.Source_Mode;
                net_command[2] = win;
                net_command[3] = src;
                equipments[0].EquipmentSend(net_command);
            }
        }
        private void button23_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                mouseOffset.X = e.X;
                mouseOffset.Y = e.Y;
                isMouseDown = true;
            }  
            src = 0x00;
            src1 = "HDMI-1";
        }
        private void button24_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                mouseOffset.X = e.X;
                mouseOffset.Y = e.Y;
                isMouseDown = true;
            }
            src = 0x01;
            src1 = "HDMI-2";
        }
        private void button25_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                mouseOffset.X = e.X;
                mouseOffset.Y = e.Y;
                isMouseDown = true;
            }
            src = 0x02;
            src1 = "HDMI-3";
        }
        private void button26_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                mouseOffset.X = e.X;
                mouseOffset.Y = e.Y;
                isMouseDown = true;
            }
            src = 0x03;
            src1 = "HDMI-4";
        }

        private void button27_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                mouseOffset.X = e.X;
                mouseOffset.Y = e.Y;
                isMouseDown = true;
            }
            src = 0x04;
            src1 = "DP-5";

        }   
        private void button25_MouseUp(object sender, MouseEventArgs e)
        {
            byte sum = 0x00;
            if (e.Button == MouseButtons.Left)
            {
                isMouseDown = false;
                //**这个是判断在哪个窗停留下的，所以应该先判断一下开窗的模式吧?**//
                switch (mode)
                {
                    case 1:
                        {
                            if (button25.Left >= 110 && button25.Left <= 430 && button25.Top >= 150 && button25.Top <= 330)
                            {
                                单画面.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                                win = 0x00;
                            }
                            label8.Text = "Single Screen:" + src1.ToString();
                            break;
                        }
                    case 2:
                        if (button25.Left >= 110 && button25.Left <= 270 && button25.Top >= 150 && button25.Top <= 330)
                        {
                            //  在画面左的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP2Left.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP2Right.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button25.Left >= 271 && button25.Left <= 430 && button25.Top >= 150 && button25.Top <= 330)  //画面右
                        {
                            //  在画面右的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            BtnP2Right.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            BtnP2Left.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);

                        }
                        if (flag1 == 1) label8.Text = "Left Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Right Screen:" + src1.ToString(); break;
                    case 3:
                        if (button25.Left >= 110 && button25.Left <= 430 && button25.Top >= 150 && button25.Top <= 240)
                        {
                            //  在画面上的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP2Up.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP2Down.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button25.Left >= 110 && button25.Left <= 430 && button25.Top >= 241 && button25.Top <= 330)   //画面下
                        {
                            //  在画面下的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            BtnP2Up.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP2Down.BackColor = System.Drawing.Color.FromArgb(210, 250, 128);
                        }
                        if (flag1 == 1) label8.Text = "Up Screen:" + src1.ToString();
                        if (flag1 == 2) label9.Text = "Down Screen:" + src1.ToString(); break;
                    case 4:
                        if (button25.Left >= 小窗.Left && button25.Left <= (小窗.Left + 小窗.Width) && button25.Top >= 小窗.Top && button25.Top <= (小窗.Top + 小窗.Height))
                        {
                            //  在小窗的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            小窗.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            大窗.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        //   else if (button25.Left >= 110 && button25.Left < 小窗.Left && button25.Left > (小窗.Left + 小窗.Width) && button25.Left <= 430 && button25.Top >= 150 && button25.Top < 小窗.Top && button25.Top > (小窗.Top + 小窗.Height) && button25.Top < 330)
                        else
                        {
                            //  在大窗的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            大窗.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            小窗.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        if (flag1 == 1) label8.Text = "Large Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Little Screen:" + src1.ToString(); break;
                    case 5:
                        if (button25.Left >= 110 && button25.Left <= 270 && button25.Top >= 150 && button25.Top <= 240)
                        {
                            //  在小窗A的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button25.Left >= 270 && button25.Left <= 430 && button25.Top >= 150 && button25.Top <= 240)
                        {
                            //  在小窗B的坐标系里面
                            flag1 = 2;
                            win = 0x02;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(221, 160, 220);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button25.Left >= 110 && button25.Left <= 270 && button25.Top >= 240 && button25.Top <= 330)
                        {
                            //  在小窗C的坐标系里面
                            flag1 = 3;
                            win = 0x01;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button25.Left >= 271 && button25.Left <= 430 && button25.Top >= 240 && button25.Top <= 330) //P4
                        {
                            //  在小窗D的坐标系里面
                            flag1 = 4;
                            win = 0x03;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(110, 50, 150);
                        }
                        if (flag1 == 1) label8.Text = "Left-Up-Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Right-Up-Screen:" + src1.ToString();
                        if (flag1 == 3) label9.Text = "Left-Down-Screen:" + src1.ToString();
                        if (flag1 == 4) label11.Text = "Rignt-Down-Screen:" + src1.ToString(); break;
                    default: break;
                }
                int left = button24.Left + 90;
                int top = button24.Top;
                button25.Location = new Point(left, top);
                /*  button25.Visible = false;
                  button23.Visible = true;
                  button24.Visible = true;
                  button26.Visible = true;
                  button27.Visible = true;*/
            }

            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x05);
                equipments[0].WriteByteToSerialPort(win);
                equipments[0].WriteByteToSerialPort(src);
                sum = (byte)(0x66 + 0x05 + win + src);
                equipments[0].WriteByteToSerialPort(sum);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.Source_Mode;
                net_command[2] = win;
                net_command[3] = src;
                equipments[0].EquipmentSend(net_command);
            }
        }

        private void button17_Click(object sender, EventArgs e)
        {
            flag_90 = (byte)~(flag_90 | 0xfe);
      
            if (flag_90 == 1)
            {
                if (col == "2")
                {
                    button18.Enabled = true;
                    button18.Visible = true;
                }                    
                else
                    button18.Enabled = false;
            }
            else if (flag_90 == 0)
            {
                if (row == "2")
                {
                    button18.Enabled = true;
                    button18.Visible = true;
                }
                else
                    button18.Enabled = false;
            }   
            byte sum = 0x00;
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x02);
                equipments[0].WriteByteToSerialPort(flag_90);
                equipments[0].WriteByteToSerialPort(0x00);
                sum = (byte)(0x66 + 0x02 + flag_90 + 0x00);
                equipments[0].WriteByteToSerialPort(sum);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.Rotate_90;
                net_command[2] = flag_90;
                net_command[3] = 0x00;
                equipments[0].EquipmentSend(net_command);

            }           
        }

      

        private void button23_MouseMove(object sender, MouseEventArgs e)
        {
            if (isMouseDown)
            {
                int left = button23.Left + e.X - mouseOffset.X;
                int top = button23.Top + e.Y - mouseOffset.Y;
                if (left > 600)
                {
                    left = 600;

                }
                if (left < 0)
                {
                    left = 0;

                }

                if (top > 800)
                {
                    top = 800;
                }
                if (top < 0)
                {
                    top = 0;
                }
                button23.Location = new Point(left, top);
            }
        }

        private void button24_MouseMove(object sender, MouseEventArgs e)
        {
            if (isMouseDown)
            {
                int left = button24.Left + e.X - mouseOffset.X;
                int top = button24.Top + e.Y - mouseOffset.Y;
                if (left > 600)
                {
                    left = 600;

                }
                if (left < 0)
                {
                    left = 0;

                }

                if (top > 800)
                {
                    top = 800;
                }
                if (top < 0)
                {
                    top = 0;
                }
                //*******就是这句话，导致控件可以随鼠标的移动而移动*******//
                button24.Location = new Point(left, top);
            }
        }

        private void button25_MouseMove(object sender, MouseEventArgs e)
        {
            if (isMouseDown)
            {
                int left = button25.Left + e.X - mouseOffset.X;
                int top = button25.Top + e.Y - mouseOffset.Y;
                if (left > 600)
                {
                    left = 600;

                }
                if (left < 0)
                {
                    left = 0;

                }

                if (top > 800)
                {
                    top = 800;
                }
                if (top < 0)
                {
                    top = 0;
                }
                //*******就是这句话，导致控件可以随鼠标的移动而移动*******//
                button25.Location = new Point(left, top);
            }
        }

        private void button26_MouseMove(object sender, MouseEventArgs e)
        {
            if (isMouseDown)
            {
                int left = button26.Left + e.X - mouseOffset.X;
                int top = button26.Top + e.Y - mouseOffset.Y;
                if (left > 600)
                {
                    left = 600;

                }
                if (left < 0)
                {
                    left = 0;

                }

                if (top > 800)
                {
                    top = 800;
                }
                if (top < 0)
                {
                    top = 0;
                }
                //*******就是这句话，导致控件可以随鼠标的移动而移动*******//
                button26.Location = new Point(left, top);
            }
        }

        private void button27_MouseMove(object sender, MouseEventArgs e)
        {
            if (isMouseDown)
            {
                int left = button27.Left + e.X - mouseOffset.X;
                int top = button27.Top + e.Y - mouseOffset.Y;
                if (left > 600)
                {
                    left = 600;

                }
                if (left < 0)
                {
                    left = 0;

                }

                if (top > 800)
                {
                    top = 800;
                }
                if (top < 0)
                {
                    top = 0;
                }
                //*******就是这句话，导致控件可以随鼠标的移动而移动*******//
                button27.Location = new Point(left, top);
            }
        }

        private void label9_Click(object sender, EventArgs e)
        {

        }

        private void label10_Click(object sender, EventArgs e)
        {

        }

        private void 拼接模式_Click(object sender, EventArgs e)
        {

        }
        private void label2_Click(object sender, EventArgs e)
        {

        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {

        }

        private void btnConnSure_Click(object sender, EventArgs e)
        {
            connect.Enabled = true;
            Boolean checkFlag = false;
            tip = 1;
             #region 检测串口跟网口打开后是否符合格式要求
              if (radioPUart.Checked)
              {
                  if (comPCom.Text == "")
                  {
                      checkFlag = true;
                  }
              }
              else
              {
                  if (textPIP.Text.Length < 7)
                  {
                      checkFlag = true;
                  }
                  if ((textPPort.Text.Length < 1) || (int.Parse(textPPort.Text) < 1))
                  {
                      checkFlag = true;
                  }
              }
              #endregion
              if (checkFlag)
              {
                  MessageBox.Show("Please check the incorrect information！");
              }
              else
              {

                  equipments[0].UUart = radioPUart.Checked;  //这个不就是把有无用串口的信息传递出来了吗
                  equipments[0].ComNameStr = comPCom.Text;    //这里发生了调用不到的错误
                  equipments[0].ComBps = int.Parse(comPBps.Text);//这里将字符串转换为整数
                  equipments[0].NetIpStr = textPIP.Text;
                  equipments[0].NetPort = int.Parse(textPPort.Text);            
              }
             equipments[0].UUart = radioPUart.Checked;  //这个不就是把有无用串口的信息传递出来了吗
             equipments[0].ComNameStr = comPCom.Text;    //这里发生了调用不到的错误        
        }
        private void button10_Click(object sender, EventArgs e)
        {
            comPCom.Items.Clear();                                        //清空ComboBox内容
            string[] str = SerialPort.GetPortNames();
            if (str != null)
            {
                foreach (string s in str)
                {
                    comPCom.Items.Add(s);
                }
            }
        }

        private void radioPUart_CheckedChanged(object sender, EventArgs e)
        {
            textPIP.Enabled = radioPNet.Checked;
            textPPort.Enabled = radioPNet.Checked;
            comPCom.Enabled = radioPUart.Checked;
            button10.Enabled = true;
            connect.Enabled = false;
        }

        private void function_Enter(object sender, EventArgs e)
        {

        }

        private void radioPNet_CheckedChanged(object sender, EventArgs e)
        {
            connect.Enabled = false;
            button10.Enabled = false;
        }


        private void button4_Click(object sender, EventArgs e)
        {
            byte sum;
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x08);
                equipments[0].WriteByteToSerialPort(0x01);
                equipments[0].WriteByteToSerialPort(0x00);
                sum = (byte)(0x66 + 0x08 + 0x01 + 0x00);
                equipments[0].WriteByteToSerialPort(sum);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.Dhcp;
                net_command[2] = 0x01;
                net_command[3] = 0x00;
                equipments[0].EquipmentSend(net_command);
            }

            button4.Enabled = false;
            button11.Enabled = true;
        }
		
        private void button11_Click(object sender, EventArgs e)
        {
            byte sum;
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x08);
                equipments[0].WriteByteToSerialPort(0x00);
                equipments[0].WriteByteToSerialPort(0x00);
                sum = (byte)(0x66 + 0x08 + 0x00 + 0x00);
                equipments[0].WriteByteToSerialPort(sum);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.Dhcp;
                net_command[2] = 0x00;
                net_command[3] = 0x00;
                equipments[0].EquipmentSend(net_command);
            }
            button11.Enabled = false;
            button4.Enabled = true;
        }
		
        private void abule_Click(object sender, EventArgs e)
        {

        }

        private void groupBox2_Enter(object sender, EventArgs e)
        {

        }
     
        private void button26_MouseUp(object sender, MouseEventArgs e)
        {

            byte sum = 0x00;
            if (e.Button == MouseButtons.Left)
            {
                isMouseDown = false;
                //**这个是判断在哪个窗停留下的，所以应该先判断一下开窗的模式吧?**//
                switch (mode)
                {
                    case 1:
                        {
                            if (button26.Left >= 110 && button26.Left <= 430 && button26.Top >= 150 && button26.Top <= 330)
                            {
                                单画面.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                                win = 0x00;
                            }
                            label8.Text = "Single Screen:" + src1.ToString();
                            break;
                        }
                    case 2:
                        if (button26.Left >= 110 && button26.Left <= 270 && button26.Top >= 150 && button26.Top <= 330)
                        {
                            //  在画面左的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP2Left.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP2Right.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button26.Left >= 271 && button26.Left <= 430 && button26.Top >= 150 && button26.Top <= 330)  //画面右
                        {
                            //  在画面右的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            BtnP2Right.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            BtnP2Left.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);

                        }
                        if (flag1 == 1) label8.Text = "Left Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Right Screen:" + src1.ToString(); break;
                    case 3:
                        if (button26.Left >= 110 && button26.Left <= 430 && button26.Top >= 150 && button26.Top <= 240)
                        {
                            //  在画面上的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP2Up.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP2Down.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button26.Left >= 110 && button26.Left <= 430 && button26.Top >= 241 && button26.Top <= 330)   //画面下
                        {
                            //  在画面下的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            BtnP2Up.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP2Down.BackColor = System.Drawing.Color.FromArgb(210, 250, 128);
                        }
                        if (flag1 == 1) label8.Text = "Up Screen:" + src1.ToString();
                        if (flag1 == 2) label9.Text = "Down Screen:" + src1.ToString(); break;
                    case 4:
                        if (button26.Left >= 小窗.Left && button26.Left <= (小窗.Left + 小窗.Width) && button26.Top >= 小窗.Top && button26.Top <= (小窗.Top + 小窗.Height))
                        {
                            //  在小窗的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            小窗.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            大窗.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        // else if (button26.Left >= 110 && button26.Left < 小窗.Left && button26.Left > (小窗.Left + 小窗.Width) && button26.Left <= 430 && button26.Top >= 150 && button26.Top < 小窗.Top && button26.Top > (小窗.Top + 小窗.Height) && button26.Top < 330)
                        else
                        {
                            //  在大窗的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            大窗.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            小窗.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        if (flag1 == 1) label8.Text = "Large Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Little Screen:" + src1.ToString(); break;
                    case 5:
                        if (button26.Left >= 110 && button26.Left <= 270 && button26.Top >= 150 && button26.Top <= 240)
                        {
                            //  在小窗A的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button26.Left >= 270 && button26.Left <= 430 && button26.Top >= 150 && button26.Top <= 240)
                        {
                            //  在小窗B的坐标系里面
                            flag1 = 2;
                            win = 0x02;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(221, 160, 220);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button26.Left >= 110 && button26.Left <= 270 && button26.Top >= 240 && button26.Top <= 330)
                        {
                            //  在小窗C的坐标系里面
                            flag1 = 3;
                            win = 0x01;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button26.Left >= 271 && button26.Left <= 430 && button26.Top >= 240 && button26.Top <= 330) //P4
                        {
                            //  在小窗D的坐标系里面
                            flag1 = 4;
                            win = 0x03;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(110, 50, 150);
                        }
                        if (flag1 == 1) label8.Text = "Left-Up-Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Right-Up-Screen:" + src1.ToString();
                        if (flag1 == 3) label9.Text = "Left-Down-Screen:" + src1.ToString();
                        if (flag1 == 4) label11.Text = "Rignt-Down-Screen:" + src1.ToString(); break;
                    default: break;
                }
                int left = button25.Left + 90;
                int top = button25.Top;
                button26.Location = new Point(left, top);
                /*   button26.Visible = false;
                   button23.Visible = true;
                   button25.Visible = true;
                   button24.Visible = true;
                   button27.Visible = true;*/
            }

            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x05);
                equipments[0].WriteByteToSerialPort(win);
                equipments[0].WriteByteToSerialPort(src);
                sum = (byte)(0x66 + 0x05 + win + src);
                equipments[0].WriteByteToSerialPort(sum);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.Source_Mode;
                net_command[2] = win;
                net_command[3] = src;
                equipments[0].EquipmentSend(net_command);
            }

        }

        private void button27_MouseUp(object sender, MouseEventArgs e)
        {

            byte sum = 0x00;
            if (e.Button == MouseButtons.Left)
            {
                isMouseDown = false;
                //**这个是判断在哪个窗停留下的，所以应该先判断一下开窗的模式吧?**//
                switch (mode)
                {
                    case 1:
                        {
                            if (button27.Left >= 110 && button27.Left <= 430 && button27.Top >= 150 && button27.Top <= 330)
                            {
                                单画面.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                                win = 0x00;
                            }
                            label8.Text = "Single Screen:" + src1.ToString();
                            break;
                        }
                    case 2:
                        if (button27.Left >= 110 && button27.Left <= 270 && button27.Top >= 150 && button27.Top <= 330)
                        {
                            //  在画面左的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP2Left.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP2Right.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button27.Left >= 271 && button27.Left <= 430 && button27.Top >= 150 && button27.Top <= 330)  //画面右
                        {
                            //  在画面右的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            BtnP2Right.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            BtnP2Left.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);

                        }
                        if (flag1 == 1) label8.Text = "Left Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Right Screen:" + src1.ToString(); break;
                    case 3:
                        if (button27.Left >= 110 && button27.Left <= 430 && button27.Top >= 150 && button27.Top <= 240)
                        {
                            //  在画面上的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP2Up.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP2Down.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button27.Left >= 110 && button27.Left <= 430 && button27.Top >= 241 && button27.Top <= 330)   //画面下
                        {
                            //  在画面下的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            BtnP2Up.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP2Down.BackColor = System.Drawing.Color.FromArgb(210, 250, 128);
                        }
                        if (flag1 == 1) label8.Text = "Up Screen:" + src1.ToString();
                        if (flag1 == 2) label9.Text = "Down Screen:" + src1.ToString(); break;
                    case 4:
                        if (button27.Left >= 小窗.Left && button27.Left <= (小窗.Left + 小窗.Width) && button27.Top >= 小窗.Top && button27.Top <= (小窗.Top + 小窗.Height))
                        {
                            //  在小窗的坐标系里面
                            flag1 = 2;
                            win = 0x01;
                            小窗.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            大窗.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        //   else if(button27.Left>=110 && button27.Left < 小窗.Left && button27.Left >(小窗.Left + 小窗.Width) && button27.Left<=430 && button27.Top >=150 && button27.Top<小窗.Top && button27.Top > (小窗.Top + 小窗.Height) && button27.Top<330)
                        else
                        {
                            //  在大窗的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            大窗.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            小窗.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        if (flag1 == 1) label8.Text = "Large Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Little Screen:" + src1.ToString(); break;
                    case 5:
                        if (button27.Left >= 110 && button27.Left <= 270 && button27.Top >= 150 && button27.Top <= 240)
                        {
                            //  在小窗A的坐标系里面
                            flag1 = 1;
                            win = 0x00;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button27.Left >= 270 && button27.Left <= 430 && button27.Top >= 150 && button27.Top <= 240)
                        {
                            //  在小窗B的坐标系里面
                            flag1 = 2;
                            win = 0x02;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(221, 160, 220);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button27.Left >= 110 && button27.Left <= 270 && button27.Top >= 240 && button27.Top <= 330)
                        {
                            //  在小窗C的坐标系里面
                            flag1 = 3;
                            win = 0x01;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                        }
                        else if (button27.Left >= 271 && button27.Left <= 430 && button27.Top >= 240 && button27.Top <= 330) //P4

                        {
                            //  在小窗D的坐标系里面
                            flag1 = 4;
                            win = 0x03;
                            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
                            BtnP4D.BackColor = System.Drawing.Color.FromArgb(110, 50, 150);
                        }
                        if (flag1 == 1) label8.Text = "Left-Up-Screen:" + src1.ToString();
                        if (flag1 == 2) label10.Text = "Right-Up-Screen:" + src1.ToString();
                        if (flag1 == 3) label9.Text = "Left-Down-Screen:" + src1.ToString();
                        if (flag1 == 4) label11.Text = "Rignt-Down-Screen:" + src1.ToString(); break;
                    default: break;
                }
                int left = button26.Left + 90;
                int top = button26.Top;
                button27.Location = new Point(left, top);
                /*   button27.Visible = false;
                   button23.Visible = true;
                   button25.Visible = true;
                   button26.Visible = true;
                   button24.Visible = true;*/
            }

            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x05);
                equipments[0].WriteByteToSerialPort(win);
                equipments[0].WriteByteToSerialPort(src);
                sum = (byte)(0x66 + 0x05 + win + src);
                equipments[0].WriteByteToSerialPort(sum);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.Source_Mode;
                net_command[2] = win;
                net_command[3] = src;
                equipments[0].EquipmentSend(net_command);
            }

        }

        private void label8_Click(object sender, EventArgs e)
        {

        }

        private void timeDelay(int iInterval)
        {
            DateTime now = DateTime.Now;
            while (now.AddMilliseconds(iInterval) > DateTime.Now)
            {
            }
            return;
        }

        public  static void Delay(int milliSecond)
        {
            int start = Environment.TickCount;
            while(Math.Abs(Environment.TickCount-start)<milliSecond)    //小于多少毫秒则继续运行下面的程序
            {
                Application.DoEvents();                                //处理一些杂碎事件
            }
        }
        private void 单画面_Click(object sender, EventArgs e)
        {        
            win = 0x00;
           单画面.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
        }

        private void 小窗_Click(object sender, EventArgs e)
        {        
            win = 0x01;
            flag1 = 2;
            小窗.BackColor = System.Drawing.Color.FromArgb(128, 255, 128);
            大窗.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
        }

        private void button32_Click(object sender, EventArgs e)  //xia
        {
            byte sum = 0x00;
            if (tag == 1)
            {
                move_model = 1;
                if (value_V <100)
                    value_V = (byte)(value_V +10);
                else value_V = 100;            
                if (connect_flag == 0)
                {
                    equipments[0].WriteByteToSerialPort(0x66);
                    equipments[0].WriteByteToSerialPort(0x06);
                    equipments[0].WriteByteToSerialPort(move_model);
                    equipments[0].WriteByteToSerialPort(value_V);
                    sum = (byte)(0x66 + 0x06 + move_model + value_V);
                    equipments[0].WriteByteToSerialPort(sum);
                }
                else
                {
                    net_command[1] = (byte)Equipment.CmdType_a.Pip_Loc;
                    net_command[2] = move_model;
                    net_command[3] = value_V;
                    equipments[0].EquipmentSend(net_command);
                }
                小窗.Top = 小窗.Top + step_U_D;
                if (小窗.Top > (330-小窗.Height))
                    小窗.Top = (330 - 小窗.Height);
            }
        }

        private void BtnP4A_Click(object sender, EventArgs e)
        {
            flag = 3;
            win = 0x00;
            flag1 = 1;

           /* BtnP4A.Enabled = true;
            BtnP4B.Enabled = false;
            BtnP4C.Enabled = false;
            BtnP4D.Enabled = false;*/
            BtnP4A.BackColor = System.Drawing.Color.FromArgb(128,255,128);
            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224,224,224);
            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224,224,224);
            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224,224,224);
        }

        private void BtnP4C_Click(object sender, EventArgs e)
        {
            flag = 3;
            win = 0x01;
            flag1 = 3;
         
            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224,224,224);
            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
            BtnP4C.BackColor = System.Drawing.Color.FromArgb(233, 150, 122);
            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
        }

        private void BtnP4B_Click(object sender, EventArgs e)
        {
            flag = 3;
            win = 0x02;
            flag1 = 2;
            /*  BtnP4A.Enabled = false;
              BtnP4B.Enabled = true;
              BtnP4C.Enabled = false;
              BtnP4D.Enabled = false;*/
            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
            BtnP4B.BackColor = System.Drawing.Color.FromArgb(221,160,220);
            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
            BtnP4D.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
        }

        private void BtnP4D_Click(object sender, EventArgs e)
        {
            flag = 3;
            win = 0x03;
            flag1 = 4;       
            BtnP4A.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
            BtnP4B.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
            BtnP4C.BackColor = System.Drawing.Color.FromArgb(224, 224, 224);
            BtnP4D.BackColor = System.Drawing.Color.FromArgb(110, 50,  150);
        }

        private void 确定键_Click(object sender, EventArgs e)
        {
            if (row == "1" || row == "2" || row == "3" || row == "4" || row == "5" || row == "6" || row == "7" || row == "8" || row == "9" || row == "10" || row == "11" || row == "12" || row == "13" || row == "14" || row == "15" || row == "16")
            {
                if (col == "1" || col == "2" || col == "3" || col == "4" || col == "5" || col == "6" || col == "7" || col == "8" || col == "9" || col == "10" || col == "11" || col == "12" || col == "13" || col == "14" || col == "15" || col == "16")
                {
                    拼接模式.Text = "拼接模式：" + row + "*" + col;
                    x1 = Convert.ToByte(row);
                    y1 = Convert.ToByte(col);
                }
                else
                    MessageBox.Show("Column value The value ranges from 1 to 16");
            }
            else
                MessageBox.Show("Enter a line value ranging from 1 to 16");       
            if (flag_90 == 0 && x1 == 2)
            {
                button18.Visible = true;
                button18.Enabled = true;
            }
               
            else if (flag_90 == 1 && y1 == 2)
            {
                button18.Visible = true;
                button18.Enabled = true;
            }
              
            else
            {
                button18.Visible = false;
                button18.Enabled = false;
            }
              
            byte sum = 0x00;
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x01);
                equipments[0].WriteByteToSerialPort(x1);
                equipments[0].WriteByteToSerialPort(y1);
                sum = (byte)(0x66 + 0x01 + x1 + y1);
                equipments[0].WriteByteToSerialPort(sum);
            }
            else
            {
                net_command[1] = (byte)Equipment.CmdType_a.pin_jie;
                net_command[2] = (byte)(x1);
                net_command[3] = (byte)(y1);
                equipments[0].EquipmentSend(net_command);
            }
            Secret = 10;
         
        }

        private void button15_Click(object sender, EventArgs e)   //1*3模式
        {
            txtRow.Text = 1.ToString();
            txtCol.Text = 3.ToString();
            button18.Enabled = false;
            if (connect_flag == 0)
            {
                equipments[0].WriteByteToSerialPort(0x66);
                equipments[0].WriteByteToSerialPort(0x01);
                equipments[0].WriteByteToSerialPort(0x01);
                equipments[0].WriteByteToSerialPort(0x03);
                equipments[0].WriteByteToSerialPort(0x6b);
            }
         else
            {
                net_command[1] = (byte)Equipment.CmdType_a.pin_jie;
                net_command[2] = (byte)0x01;
                net_command[3] = (byte)0x03;
                equipments[0].EquipmentSend(net_command);
            }
          
            拼接模式.Text = "拼接模式:1*3";
            Secret = Secret / 2;
            row = "1";
        
        }

        private void button1_Click(object sender, EventArgs e)  //小窗变小
        {
            byte sum = 0;
            if (tag == 1)
            {
                flag = 4;
                if (size > 0)
                {
                    size--;
                    label4.Text = "size:" + size.ToString();
                }
                else
                {
                    size = (byte)(size-0);
                    label4.Text = "size:" + size.ToString();
                }
                if (connect_flag == 0)
                {
                    equipments[0].WriteByteToSerialPort(0x66);
                    equipments[0].WriteByteToSerialPort(0x07);
                    equipments[0].WriteByteToSerialPort(size);
                    equipments[0].WriteByteToSerialPort(0x00);
                    sum = (byte)(0x66 + 0x07 + size + 0x00);
                    equipments[0].WriteByteToSerialPort(sum);
                }
                else
                {
                    net_command[1] = (byte)Equipment.CmdType_a.Pip_Size;
                    net_command[2] = size;
                    net_command[3] = 0x00;
                    equipments[0].EquipmentSend(net_command);
                }
                if (小窗.Height <= 30 || 小窗.Width <=100)

                {
                    小窗.Height = 小窗.Height + 0;
                    小窗.Width = 小窗.Width + 0;
                }
           
                else if (小窗.Left == 110 && 小窗.Top == 150)  //左上
                {
                    小窗.Left = 110;
                    小窗.Top = 150;
                    小窗.Height = 小窗.Height - 10;
                    小窗.Width = 小窗.Width - 10;
                 
                }

                else if ((小窗.Height + 小窗.Top) < 330 && 小窗.Left == 110&&小窗.Top>150)  //左中贴边
                {
                    小窗.Left = 小窗.Left + 0;
                    小窗.Top = 小窗.Top +5;
                    小窗.Height = 小窗.Height - 10;
                    小窗.Width = 小窗.Width - 10;
                  
                }
                else if ((小窗.Height + 小窗.Top) >= 330 && 小窗.Left == 110)  //左下贴边
                {
                   
                    小窗.Height = 小窗.Height - 10;
                    小窗.Width = 小窗.Width - 10;
                    小窗.Left = 小窗.Left + 0;
                    小窗.Top = 小窗.Top + 10;
                }
                else if ((小窗.Height + 小窗.Top) >= 330 && (小窗.Left > 110 && (小窗.Left + 小窗.Width) < 430))  //底中贴边
                {
                    小窗.Height = 小窗.Height - 10;
                    小窗.Width = 小窗.Width - 10;
                    小窗.Left = 小窗.Left + 5;
                    小窗.Top = 小窗.Top + 10;
                   
                }
                else if (小窗.Bottom == 330 && 小窗.Right == 430)  //右下贴边
                {
                    
                    小窗.Height = 小窗.Height - 10;
                    小窗.Width = 小窗.Width - 10;
                    小窗.Left = 小窗.Left + 10;
                    小窗.Top = 小窗.Top + 10;
                }

                else if ((小窗.Height + 小窗.Top) < 330 && 小窗.Top > 150 && (小窗.Width + 小窗.Left) == 430) //右中贴边
                {
                  
                    小窗.Height = 小窗.Height - 10;
                    小窗.Width = 小窗.Width - 10;
                    小窗.Left = 小窗.Left + 10;
                    小窗.Top = 小窗.Top + 5;
                }
                else if (小窗.Top == 150 && (小窗.Width + 小窗.Left) == 430) //右上贴边
                {
                 
                    小窗.Left = 小窗.Left + 10;
                    小窗.Top = 小窗.Top + 0;
                    小窗.Height = 小窗.Height - 10;
                    小窗.Width = 小窗.Width - 10;
                }
                else if (小窗.Top == 150 && (小窗.Width + 小窗.Left) <= 430 && 小窗.Left> 110) //顶中贴边
                {
                  
                    小窗.Left = 小窗.Left +5;
                    小窗.Top = 小窗.Top -0;
                    小窗.Height = 小窗.Height - 10;
                    小窗.Width = 小窗.Width - 10;
                }
                else if(小窗.Top>150&&(小窗.Top + 小窗.Height) <330 && 小窗.Left>110&&(小窗.Width + 小窗.Left) < 430)
                {
                  
                    小窗.Height = 小窗.Height -10;
                    小窗.Width = 小窗.Width -10;
                    小窗.Left = 小窗.Left + 5;
                    小窗.Top =小窗.Top+5;
                   
                }
                else
                {
                    小窗.Left = 小窗.Left + 2;
                    小窗.Top = 小窗.Top - 2;
                    小窗.Height = 小窗.Height -10;
                    小窗.Width = 小窗.Width - 10;
                }
                step_L_R = (byte)((430 - 110 - 小窗.Width) / 10);
                step_U_D = (byte)((330 - 150 - 小窗.Height) / 10);
            }
           
        }
          
      
    }
}

